//Softare para respirador Frax3D - Ultima actualización 2020/04/09
//Info del proyecto -> https://www.frax3d.com/respiradores


//defines pins
const int stepPin = 6;  //PUL+ -Pulse
const int dirPin = 5; //DIR+ -Direction
const int finalcarrera = 11; //Pulsador final de carrera
const int buzzer = 10; //zumbador o altavoz de aviso



//Variables
const int stepsxrev = 800; //pasos por revolucion del motor
const int mmxrev= 8; //milimetros de desplazamiento del husillo por revolución

int stepdelayInsp = 0;    //microsegundos entre paso y paso - Inspiración
int stepdelayExp = 0;     //microsegundos entre paso y paso - Expiración
int stepdelay = 0;        //microsegundos entre paso y paso - General

int targetsteps =0;         // pasos necesarios para llegar al punto marcado

int t1 = 500;               //tiempo de espera Inspiración (milisegundos)
int t2 = 500;               //tiempo de espera Expiración (milisegundos)

int disp = 0 ;              //desplazamiento
int RPM = 0;                //Respiraciones por minuto
int ratio = 2 ;             //Ratio inspiracion/expiracion
int ratioDen = 2 ;          //Para el calculo Ratio inspiracion/expiracion
int tCiclo = 0;             //Tiempo de ciclo
int tInsp = 0;              //Tiempo inspiración
int tExp = 0;               //Tiempo expiración

int i = 0;                  //contar resp min
unsigned long start, finish, elapsed, over;    //Para calcular el tiempo
float h, m, s;


void setup() {
  //Iniciamos comunicación con el puerto serie
  Serial.begin(9600);
  Serial.setTimeout(100);

  //Sets the pins as Outputs
  pinMode(stepPin,OUTPUT);
  pinMode(dirPin,OUTPUT);
  pinMode(finalcarrera,INPUT);
  pinMode(buzzer,OUTPUT);


   //Leemos valor de desplazamiento
   Serial.println("DESPLAZAMIENTO mm (50 - 80):");
   while (!Serial.available() > 0);   // Esperamos valor
   {
      disp = Serial.readString().toInt();
      Serial.print("DESPLAZAMIENTO SELEC: ");
      Serial.println(disp);
      Serial.println(" ");
    }

   //Leemos valor respiraciones minuto
   Serial.println("RESPIRACIONES MINUTO (10 -20):");
   while (!Serial.available() > 0);   // Esperamos valor
   {
      RPM = Serial.readString().toInt();
      Serial.print("RESPIRACIONES SELEC: ");
      Serial.println(RPM);
      Serial.println(" ");
    }

   //Leemos valor Ratio I/E
   Serial.println("RATIO INSPIRACIÓN/EXPIRACIÓN (1, 2, 3, 4):");
   while (!Serial.available() > 0);   // Esperamos valor
   {
      ratio = Serial.readString().toInt();
      Serial.print("RATIO I/O SELEC: 1:");
      Serial.println(ratio);
      Serial.println(" ");
    }

    //Calculos iniciales
    tCiclo = (60000/RPM) ;
    Serial.print("Tiempo de ciclo: ");
    Serial.println(tCiclo);
    ratioDen = 1+ratio;
    tInsp = (tCiclo/ratioDen) ;
    Serial.print("Tiempo de Inspiración: ");
    Serial.println(tInsp);
    tExp = ((tCiclo*ratio)/ratioDen) ;
    Serial.print("Tiempo de Expiración: ");
    Serial.println(tExp);

    targetsteps = (disp)*(stepsxrev/mmxrev);   //Pasos para el desplazamiento
    Serial.print("Pasos necesarios: ");
    Serial.println(targetsteps);

    //Si queremos velocidades diferentes de Inspiración y Expiración
    //stepdelayInsp = (((float)tInsp*1000)/((float)targetsteps*2)) ;   //microsegundos entre paso y paso - Inspiración
    //Serial.println(stepdelayInsp);
    //stepdelayExp = (((float)tExp*1000)/((float)targetsteps*2)) ;     //microsegundos entre paso y paso - Expriración
    //Serial.println(stepdelayExp);

    //Misma velocidad Inspiración/Expiración
    stepdelay = (((float)tInsp*1000)/((float)targetsteps*2)) ;   //microsegundos entre paso y paso - Insp y Exp
    Serial.print("Delay pasos: ");
    Serial.println(stepdelay);
    stepdelayInsp = stepdelay;
    stepdelayExp = stepdelay;
    

    //Home para iniciar la máquina
    Serial.println(" ");  
    Serial.print("HOME POSITION");
    
    digitalWrite(dirPin,LOW); //inicia movimiento en sentido X negativo  
    while (digitalRead(finalcarrera)==LOW){
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(stepdelayExp);
        digitalWrite(stepPin,LOW);
        delayMicroseconds(stepdelayExp);
     }
     Serial.println("  ->  Endstop");
     delay(50);

     start = millis();     // Para contar el tiempo
}



 
void loop() {

    //test para contar el tiempo
    i= i + 1;
    Serial.println(" ");
    Serial.print("Respiracion nº: ");
    Serial.println(i);     
    //test para contar el tiempo
     

     //INSPIRACIÓN
     Serial.print("INHALACION "); 
     digitalWrite(dirPin,HIGH); //inicia movimiento en sentido X positivo
     for(int i = 0; i < targetsteps; i++) { //loop de movimiento de 0 a pasos necesairos
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(stepdelayInsp);
        digitalWrite(stepPin,LOW);
        delayMicroseconds(stepdelayInsp);        
      }
      delay(50);

      //Comprobamos que el final de carrera no está pulsado -> aseguramos que se ha movido 
      if (digitalRead(finalcarrera)==HIGH)  {
        Serial.println(); 
        Serial.println();
        Serial.println("ERROR!!!!");                //Crear alarma que pare la máquina
        Serial.println();
      }
      
      //delay (t1);     //Espera -> modificar pasos

      //EXPIRACIÓN - Hasta final de carrera
      Serial.print(" ->  EXHALACION ");
      digitalWrite(dirPin,LOW); //inicia movimiento en sentido X negativo
      while (digitalRead(finalcarrera)==LOW){
          digitalWrite(stepPin,HIGH);
          delayMicroseconds(stepdelayExp);
          digitalWrite(stepPin,LOW);
          delayMicroseconds(stepdelayExp);
       }
       Serial.println(" ->  Endstop");

       if (ratio != 1) {
       delay (((ratio-1)*tInsp)-50);     //Espera lo que le falta al cilco de expiración <50 que hemos esperado extra>
       }


    //test para contar el tiempo  
    if (i == RPM) {     
      finish = millis();
      elapsed = finish - start; 
      h = int(elapsed / 3600000); 
      over = elapsed % 3600000; 
      m = int(over / 60000); 
      over = over % 60000; 
      s = int(over / 1000);
      Serial.println("CICLO COMPLETO: ");
      Serial.print(m, 0); 
      Serial.print("m "); 
      Serial.print(s, 0); 
      Serial.println("s ");
      i = 0;
      start = millis();     // Para contar el tiempo
    }
    //test para contar el tiempo


}
